<?php

/*
         PHP License Admin is Copyright 2008, Eric Schwimmer

    This program is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses/>.


		Note: This file is best viewed with 2-space tabstops
*/

include 'config.inc.php';

# Our global error/success reporting message
$msg = '';

# Our action variables
$action	= isset($_REQUEST['act']) ? $_REQUEST['act'] : 'licenses';
$search = $_REQUEST['search'];
$commit = $_REQUEST['commit'];
$abort  = $_REQUEST['abort'];
$add    = $_REQUEST['add'];
$edit   = $_REQUEST['edit'];
$del    = $_REQUEST['del'];

# Connect to our database
db_connect();

# First see if we have any subactions that needs to get taken care of
if($add or $commit)		$msg = do_commit();
elseif($edit and !$abort)	edit_page();
elseif($del and !$abort)	delete_page();

# Escape our search string, if it was set
if(isset($search)) {
	$search = mysql_escape_string($search);
	$msg = "Search results for '$search':";
}

# Print our header
print_header();

# Handle actions if no subaction set
if($action == 'licenses')				license_page();
elseif($action == 'software')		software_page();
elseif($action == 'users')			user_page();
elseif($action == 'stats')			stats_page();

else fatal("Unknown action, '$action'\n");

# Print footer and exit
print_footer();
exit;

# Connect to our db
function db_connect()
{
	global $db_host, $db_name, $db_user, $db_pass;
	mysql_pconnect($db_host, $db_user, $db_pass) or
		fatal('Unable to connect to database server');

	mysql_select_db($db_name) or 
		fatal('Unable to select database');
}

# Print out a list of all licenses
function license_page()
{
	global $search;

	$query = "SELECT id,name,notes FROM software ORDER BY name";
	$data = do_query($query);

	while($row = mysql_fetch_array($data)) {

		$sid			= $row[0];
		$sname		= $row[1];
		$notes		= $row[2];
		$anchor		= str_replace(' ', '_', $sname);
		$sw_match	= (isset($search) and strpos($sname,$search)) ? 1 : 0;

		# Build our database query
		if(isset($search) and !$sw_match)
			$q_search =	"AND (users.name LIKE '%$search%' " .
									"OR licenses.lnum LIKE '%$search%')";

		$query = "SELECT licenses.id, users.name, licenses.lnum, " .
						 "licenses.expires, users.id AS userid FROM users,licenses " .
						 "WHERE users.id = licenses.uid AND licenses.sid = '$sid' " .
						 "$q_search ORDER BY users.name";

		# Build our data table
		$fields = array('User','License #','Expires');
		$table = data_table($query, $fields, 1);
		$num_lic = mysql_affected_rows();

		# Dont print this table if we are searching and didnt get a match
		if(isset($search) and $num_lic == 0 and !$sw_match) continue;

		# Print our table header
		print	"       <div id='softwareName'>\n" .
					"         Licenses for $sname<a name='$anchor'></a>\n " .
					"         <span id='numLicenses'>($num_lic licenses)</span>\n" .
					"       </div>\n" .
					"       <div id='softwareNotes'>\n" .
					"         $notes\n" .
					"       </div>\n" . 
					data_table_header($fields, 1);

		# Add on our 'add license' section and print the rest of the table
		$user_select = select_td('uid','users','name',NULL);
		print "            <tr>\n" .
					"              <form method='POST' class='opt' action='#$anchor'>\n" .
					"                <input type='hidden' name='add' value='1'>\n" .
					"                <input type='hidden' name='sid' value='$sid'>\n" .
					"                <td class='cell'>\n" .
					"                  $user_select\n" .
					"                </td>\n" .
					"                <td class='cell'>\n" .
					"                  <input type='text' name='lnum' id='lnum'></input>\n" .
					"                </td>\n" .
					"                <td class='cell'>\n" .
					"                  <input type='text' name='expires' id='expires'></input>\n" .
					"                </td>\n" .
					"                <td align='center' colspan=2 class='opt'>\n" .
					"                  <input type='image' class='addButton'\n" .
					"                    src='images/add.png'>\n" .
					"                </td>\n" .
					"              </form>\n" .
					"            </tr>\n" .
					$table . 
					"          </table>\n";

  }
}

# Print out a list of all software types
function software_page()
{
	global $search;

  # Build our DB query and data table header
	if(isset($search)) 
		$q_search = "WHERE name LIKE '%$search%' OR notes LIKE '%$search%'";
	$query	= "select id,name,notes from software $q_search order by name";

	$fields = array('Name', 'Notes'); 
	print data_table_header($fields, 1);

	# Add on our 'add user' section and print our data table
	print "            <tr>\n" .
	      "              <form method='POST' class='opt'>\n" .
				"                <input type='hidden' name='add' value='1'>\n" .
				"                <td class='cell'>\n" .
				"                  <input type='text' name='software'></input>\n" .
				"                </td>\n" .
				"                <td class='cell'>\n" .
				"                  <input type='text' size='50' name='notes'></input>\n" .
				"                </td>\n" .
				"                <td align='center' colspan=2 class='opt'>\n" .
				"                  <input type='image' class='addButton'\n" .
				"                    src='images/add.png'>\n" .
				"                </td>\n" .
				"              </form>\n";
				"            </tr>\n" .

  # Now print the data
	print data_table($query, $fields, 1) .
				"          </table>\n";
}
			
# Print out a list of all users
function user_page()
{
	global $search;

  # Build our DB query and data table
	if(isset($search)) $q_search = " AND (name like '%$search%')";
	$query	= "SELECT id,name FROM users WHERE id > 0 $q_search ORDER BY name";

	$fields = array('Name'); 
	print data_table_header($fields, 1);

	# Add on our 'add user' section
	print "            <tr>\n" .
	      "              <form method='POST' class='opt'>\n" .
				"                <input type='hidden' name='add' value='1'>\n" .
				"                <td class='cell'>\n" .
				"                  <input type='text' name='user'></input>\n" .
				"                </td>\n" .
				"                <td align='center' colspan=2 class='opt'>\n" .
				"                  <input type='image' class='addButton'\n" .
				"                    src='images/add.png'>\n" .
				"                </td>\n" .
				"              </form>\n";
				"            </tr>\n";

  # Print the rest of our data table
	print data_table($query, $fields, 1) .
				"          </table>\n";
}

function edit_page()
{
  # Quit here, since we dont want to fall through to the original page function
	global $action, $msg, $edit;

	$id  = $edit;
	$output = "          <form method='POST'>\n";

	# Quick sanity checks
	if (!isset($id)) fatal("Missing entry ID");
	if (!is_numeric($id)) fatal("Id must be numeric ($id)");
	if ($id < 1) fatal("Id must be greater than zero");

  # Set up our DB query
	if($action == 'licenses') 
		$query = "SELECT licenses.id, users.id, software.id, licenses.lnum, " .
						 "licenses.expires FROM users,software,licenses " .
						 "WHERE users.id = licenses.uid AND software.id = licenses.sid " .
						 "AND licenses.id = $id";
	if($action == 'users') 
		$query = "SELECT id,name from users where id = $id";
	if($action == 'software') 
		$query = "SELECT id,name,notes from software where id = $id";

	$data = do_query($query);
	$row = mysql_fetch_array($data);

  # Build our type-specific table
	if($action == 'licenses') {
		$fields = array('User','Software','License #','Expires');

		$output .= 
		       "      <table id='data'>\n" . data_header($fields) .
		       "        <input type='hidden' name='edit' value='{$row[0]}'>\n" .
		       "        <tr>\n" .
					 "          <td>\n" .
	         select_td('uid','users','name',$row[1]) .
					 "          </td>\n" .
					 "          <td>\n" .
					 select_td('sid','software','name',$row[2]) .
					 "          </td>\n" .
					 "          <td>\n" .
					 "            <input type='text' id='lnum' name='lnum' value='{$row[3]}'>\n" .
					 "          </td>\n" .
					 "          <td>\n" .
					 "            <input type='text' id='expires'  name='expires' value='{$row[4]}'>\n" .
					 "          </td>\n" .
		       "        </tr>\n";

	}
	elseif($action == 'users') {
		$fields = array('User');
		$output .= 
		       "      <table id='data'>\n" . data_header($fields) .
		       "        <input type='hidden' name='edit' value='{$row[0]}'>\n" .
		       "        <tr>\n" .
					 "          <td>\n" .
					 "            <input type='text' name='user' value='{$row[1]}'>\n" .
					 "          </td>\n" .
		       "        </tr>\n";
	}
	elseif($action == 'software') {
		$fields = array('Software','Notes');
		$output .= 
		       "      <table id='data'>\n" . data_header($fields) .
		       "        <input type='hidden' name='edit' value='{$row[0]}'>\n" .
		       "        <tr>\n" .
					 "          <td>\n" .
					 "            <input type='text' name='software' value='{$row[1]}'>\n" .
					 "          </td>\n" .
					 "          <td>\n" .
					 "            <input type='text' name='notes' size='50' value='{$row[2]}'>\n" .
					 "          </td>\n" .
		       "        </tr>\n";
	}
	else 
	  error("No action associate with delete?");

  # Print our confirmation message
	print_header();
	print $output .
				"        </table>\n" .
				"        <div id='confirm'>\n" .
				"            <input type='hidden' name='edit' value='$id'></input>\n" .
				"            <input type='submit' name='commit' value='Update' class='confButton'>\n" .
				"            <input type='submit' name='abort' value='Abort' class='abortButton'>\n" .
				"          </form>\n" .
				"        </div>\n";

	print_footer();
	exit;
}

# Page to confirm the deletion of an entry
function delete_page()
{
	global $action, $msg, $del;

	$id = $del;
	# Quick sanity checks
	if (!isset($id)) fatal("Missing entry ID");
	if (!is_numeric($id)) fatal("Id must be numeric ($id)");
	if ($id < 1) fatal("Id must be greater than zero");


  # Build our table-specific query
	if($action == 'licenses') {
		$query = "SELECT licenses.id, users.name, software.name, licenses.lnum, " .
						 "licenses.expires FROM users,software,licenses " .
						 "WHERE users.id = licenses.uid AND software.id = licenses.sid " .
						 "AND licenses.id = $id";
		$fields = array('User','Software','License #','Expires');
	}
	elseif($action == 'users') {
		$query = "SELECT id,name from users where id = $id";
		$fields = array('User');
	}
	elseif($action == 'software') {
		$query = "SELECT id,name,notes from software where id = $id";
		$fields = array('Software','Notes');
	}
	else 
	  error("No action associate with delete?");

  # Get single-entry data-table back
	$hdr = data_table_header($fields,0);
	$tbl = data_table($query, $fields, 0);

  # Make sure we arent deleting something that doesnt exist
	if(is_numeric($result)) {
	  $msg = "Requested data does not exist in database.\n";
		return;
	}

  # Print our confirmation message
	$warn_msg = '';
	if($action == 'users') 
	  $warn_msg = 'This will set all licenses for this user to "Unassigned"';
	elseif($action == 'software')
	  $warn_msg = 'WARNING: This will delete all licenses associated with this software!!';

	print_header();
	print $hdr . $tbl .
				"        </table>\n" .
				"        <div id='confirmWarn'>$warn_msg</div>\n" .
				"        <div id='confirm'>Delete this entry?\n" .
				"          <form method='POST'>\n" .
				"            <input type='hidden' name='del' value='$id'></input>\n" .
				"            <input type='submit' name='commit' value='Confirm' class='confButton'>\n" .
				"            <input type='submit' name='abort' value='Abort' class='abortButton'>\n" .
				"          </form>\n" .
				"        </div>\n";

  # Quit here, since we dont want to fall through to the original page function
	print_footer();
	exit;
}

# Page to print various statistics

function stats_page()
{

	$num_users = num_recs("SELECT count(*) FROM users");

	$data = do_query("SELECT id,name FROM software ORDER BY name");
	while($row = mysql_fetch_array($data)) {
		$id   = $row[0];
		$name = $row[1];

		$num_licenses[$name] = num_recs("select count(*) FROM licenses where sid='$id'");
	}



	print	"      <table id='data'>\n" .
				"        <tr>\n" .
				"          <td>\n" .
				"            # of Users:\n" .
				"          </td>\n" .
				"          <td>\n" .
				"            $num_users\n" .
				"          </td>\n" .
				"        </tr>\n" .
				"        <tr>\n" .
				"        </tr>\n";

	foreach ($num_licenses as $name => $num) {

		print "        <tr>\n" .
					"          <td>\n" .
					"            # $name licenses\n" .
					"          </td>\n" .
					"          <td>\n" .
					"            $num\n" .
					"          </td>\n" .
					"        </tr>\n";

	}

	print "      </table>\n";
        
}

# Determine the number of records returned by a query
function num_recs($query)
{
	$data = do_query($query);
	$row = mysql_fetch_array($data);

	return $row[0];
}

# Commit any changes we have made
function do_commit()
{
	global $action, $commit, $del, $add, $edit;

	$msg = '';

	if($del) {
		$id = $del;
		# Quick sanity checks
		if (!isset($id)) fatal("Missing entry ID");
		if (!is_numeric($id)) fatal("Id must be numeric ($id)");
		if ($id < 1) fatal("Id must be greater than zero");

		# Handle our delete commits
		if($action == 'licenses') {
			if($commit) $msg = do_delete('licenses', $id);
		}
		elseif($action == 'users') {
			if($commit) $msg = do_delete('users', $id);
		}
		elseif($action == 'software') {
			if($commit) $msg = do_delete('software', $id);
		}

		return $msg;
	}

	elseif($add) {
	
	  if($action == 'licenses') {

			$uid = $_REQUEST['uid'];
			$sid = $_REQUEST['sid'];
			$lnum = $_REQUEST['lnum'];
			$expires = $_REQUEST['expires'];
			
			# Do intensive sanity checking
			if(!isset($uid))			return "Add failed: user id required.";
			if(!isset($sid)) 			return "Add failed: missing software id.";

			if(!is_numeric($uid)) return "Add failed: user id must be numeric.";
			if(!is_numeric($sid)) return "Add failed: software id must be numeric.";
			$lnum = mysql_real_escape_string($lnum);

			# Cheat and use MYSQL for date validation (hey, I'm lazy)
			if(!$expires)	$expires = "0000-00-00";
			else {
				$expires = mysql_real_escape_string($expires);
				$data = do_query("SELECT UNIX_TIMESTAMP('$expires')");
				$row = mysql_fetch_array($data);
				if($row[0] == 0) return "Expiration must be formatted as YYYY-MM-DD";
				if($row[0] < time()) return "Expiration date must be in future";
			}

			# Make sure we our user and software id's exist
			do_query("SELECT id from users where id='$uid'");
			if(!mysql_affected_rows()) return "Invalid user ID.";
			do_query("SELECT id from software where id='$sid'");
			if(!mysql_affected_rows()) return "Invalid software ID.";

			# Make sure that license doesn't already exist
      if($lnum) {
				do_query("SELECT id from licenses where sid='$sid' and lnum='$lnum'");
			}
			else {
				do_query("SELECT id from licenses where sid='$sid' and uid='$uid'");
			}
			if(mysql_affected_rows()) return "License already assigned";

			do_query("INSERT INTO licenses (sid,uid,lnum,expires) VALUES " .
							 "($sid,$uid,'$lnum','$expires')");

			$msg = "License added";
		}

		elseif($action == 'users') {
		
			$name = $_REQUEST['user'];

			if(!$name) return "Add failed: User name required.";

			# Make sure that license doesn't already exist
			$name = mysql_real_escape_string($name);
			do_query("SELECT id from users where name='$name'");
			if(mysql_affected_rows()) return "User already exists";

			do_query("INSERT INTO users (name) VALUES ('$name')");

			$msg = "User added";
		}

		elseif($action == 'software') {

			$name		= $_REQUEST['software'];
			$notes	= $_REQUEST['notes'];

			if(!$name) return "Add failed: Software name required.";

			# Make sure that license doesn't already exist
			$name = mysql_real_escape_string($name);
			$notes = mysql_real_escape_string($notes);
			do_query("SELECT id from software where name='$name'");
			if(mysql_affected_rows()) return "Software already exists";

			do_query("INSERT INTO software (name,notes) VALUES ('$name','$notes')");

			$msg = "Software added";
		}

	}

	elseif($edit) {

		$id = $edit;
		# Quick sanity checks
		if (!isset($id)) fatal("Missing entry ID");
		if (!is_numeric($id)) fatal("Id must be numeric ($id)");
		if ($id < 1) fatal("Id must be greater than zero");
	
	  if($action == 'licenses') {

			$uid = $_REQUEST['uid'];
			$sid = $_REQUEST['sid'];
			$lnum = $_REQUEST['lnum'];
			$expires = $_REQUEST['expires'];
			
			# Do intensive sanity checking
			if(!isset($uid))			return "Update failed: user id required.";
			if(!isset($sid)) 			return "Update failed: missing software id.";

			if(!is_numeric($uid)) return "Update failed: user id must be numeric.";
			if(!is_numeric($sid)) return "Update failed: software id must be numeric.";
			$lnum = mysql_real_escape_string($lnum);

			# Cheat and use MYSQL for date validation (hey, I'm lazy)
			if(!$expires)	$expires = "0000-00-00";
			elseif($expires = "0000-00-00") {}
			else {
				$expires = mysql_real_escape_string($expires);
				$data = do_query("SELECT UNIX_TIMESTAMP('$expires')");
				$row = mysql_fetch_array($data);
				if($row[0] == 0) return "Expiration must be formatted as YYYY-MM-DD";
				if($row[0] < time()) return "Expiration date must be in future";
			}

			# Make sure we our user and software and license id's exist
			do_query("SELECT id from users where id='$uid'");
			if(!mysql_affected_rows()) return "Invalid user ID.";
			do_query("SELECT id from software where id='$sid'");
			if(!mysql_affected_rows()) return "Invalid software ID.";
			do_query("SELECT id from licenses where id='$id'");
			if(!mysql_affected_rows()) return "Invalid license ID.";

			do_query("UPDATE licenses SET sid='$sid', uid='$uid', lnum='$lnum', " .
			         "expires='$expires' WHERE id='$id'");

			$msg = "License updated";
		}

		elseif($action == 'users') {
		
			$name = $_REQUEST['user'];

			if(!$name) return "Update failed: User name required.";

			# Make sure that user exists
			$name = mysql_real_escape_string($name);
			do_query("SELECT id from users where id='$id'");
			if(!mysql_affected_rows()) return "Invalid user ID.";

			do_query("UPDATE users set name='$name' where id='$id'");

			$msg = "User updated";
		}

		elseif($action == 'software') {

			$name		= $_REQUEST['software'];
			$notes	= $_REQUEST['notes'];

			if(!$name) return "Update failed: Software name required.";

			# Make sure that license doesn't already exist
			$name		= mysql_real_escape_string($name);
			$notes	= mysql_real_escape_string($notes);
			do_query("SELECT id from software where id='$id'");
			if(!mysql_affected_rows()) return "Invalid software ID";

			do_query("UPDATE software set name='$name', notes='$notes' where id='$id'");

			$msg = "Software updated";
		}

	}
	return $msg;
}



# Delete a database entry
function do_delete($table, $id)
{
	do_query("DELETE from $table WHERE id = $id");

	if(!mysql_affected_rows()) return "Error: Entry not found.";

  # Make sure we update our licenses table, if needbe
	if($table == 'users') {
		do_query("UPDATE licenses SET uid=0 where uid='$id'");
	}
	elseif($table == 'software') {
		do_query("DELETE from licenses WHERE sid = $id");
	}
	  
	return "Entry deleted.";
}

# Do database query
function do_query($query)
{
	$data = mysql_query($query) or
		fatal("Database query '$query' failed");
	
	return $data;
}
	
# Build a select form entry from the specific DB data
function select_td($name, $table, $field, $active)
{
	$data = do_query("select id,$field from $table order by $field");

	while($row = mysql_fetch_array($data)) {
		$id = $row[0];
		$selected = ($id == $active) ? 'selected' : '';
		if($id < 1)
			$td =	"                    <option $selected value='$id'>\n" .
						"                      {$row[1]}\n" .
						"                    </option>\n" . $td;
		else
			$td .=	"                    <option $selected value='$id'>\n" .
							"                      {$row[1]}\n" .
							"                    </option>\n";
	}
	$td .=   "                </select>";

	$td = "<select name='$name' id='$table'>\n" . $td;
	return $td;
}

# Construct and return the header for our data table
function data_table_header($fields, $o)
{
	$hdr = "          <table id='data'>\n" .
	          "            <tr>\n";

	$hdr .= data_header($fields);

	# Only print our option fields if requested
	if($o) 
		$hdr .=	"              <td class='optHead'>\n" .
						"              </td>\n" .
						"              <td class='optHead'>\n" .
						"              </td>\n";

	$hdr .=		"            </tr>\n";

	return $hdr;

}
# Our generic data-table printing function
function data_table($query, $fields, $o)
{

	$tbl  = '';
	$data = do_query($query);

	# Return 0 if we didn't get any data
	if(mysql_numrows($data) == 0 and !$o) return 0;

	$i = 1;
	$numfields = count($fields);
	$rowtype = array(0 => "class='oddRow'", 1 => "class='evenRow'");

	$last = array();
	while($row = mysql_fetch_array($data)) {
		$i = !$i;
		$id = $row[0];
    $line = '';

		for($n=1; $n <= $numfields; $n++) 
			$line .=	
				"              <td class='cell'>\n" .
				"                {$row[$n]}\n" .
				"              </td>\n";
		
		if($o) $line .=
					"              <td class='opt'>\n" .
					"                <form method='POST' class='opt'>\n" .
					"                  <input type='hidden' name='edit' value='$id'></input>\n" .
					"                  <input type='image' class='editButton'\n" .
					"                    img src='images/pencil.png'>\n" .
					"                </form>\n" .
					"              </td>\n" .
					"              <td class='opt'>\n" .
					"                <form method='POST' class='opt'>\n" .
					"                  <input type='hidden' name='del' value='$id'></input>\n" .
					"                  <input type='image' class='editButton'\n" .
					"                    img src='images/cross.png'>\n" .
					"                </form>\n" .
					"              </td>\n";

		if(isset($row['userid']) and $row['userid'] < 1) 
			$last[] = $line;
		else
			$tbl .=
				"            <tr {$rowtype[$i]}>\n" .
				$line .
 				"            </tr>\n";
	}

	foreach($last as $line) {
		$i = !$i;
		$tbl .=
			"            <tr {$rowtype[$i]}>\n" .
			$line .
 			"            </tr>\n";
	}

	return $tbl;
}

# Print the header for our data table
function data_header($fields)
{
	$msg = '';

	foreach($fields as $field)
		$msg .=	"              <td class='head'>\n" .
						"                $field\n" .
						"              </td>\n";

	return $msg;
}

# Print our html header and menu
function print_header()
{
	global $action, $html_title, $page_title, $msg, $header_printed;;

	$link1 = "<a href='?act=licenses'>Licenses</a>";
	$link2 = "<a href='?act=users'>Users</a>";
	$link3 = "<a href='?act=software'>Software</a>";
	$link4 = "<a href='?act=stats'>Stats</a>";

	if($action == 'licenses') { 
		$link1 = "<span id='alink'>Licenses</span>"; 
	} elseif($action == 'users') {
		$link2 = "<span id='alink'>Users</span>"; 
	} elseif($action == 'software') { 
		$link3 = "<span id='alink'>Software</span>"; 
	} elseif($action == 'stats') { 
		$link4 = "<span id='alink'>Stats</span>"; 
	}

	print "<html>\n" .
				"  <head>\n" .
				"    <title>$html_title</title>\n" .
				"    <link rel='stylesheet' type='text/css' href='licenses.css'>\n" .
				"  </head>\n" .
				"  <body>\n" .
				"    <div id='page'>\n" .
				"      <table class='header'>\n" .
				"        <tr>\n" .
				"          <td class='title'>$page_title</td>\n" .
				"          <td class='search'>\n" .
				"            <form method='POST'>\n" .
				"              Search: <input name='search' />\n" .
				"            </form>\n" .
				"          </td>\n" .
				"        </tr>\n" .
				"      </table>\n" .
				"      <div id='menu'>\n" .
				"        <table id='menu'>\n" .
				"          <tr>\n" .
				"            <td>\n" .
				"              $link1\n" .
				"            </td>\n" .
				"            <td>\n" .
				"              $link2\n" .
				"            </td>\n" .
				"            <td>\n" .
				"              $link3\n" .
				"            </td>\n" .
				"            <td>\n" .
				"              $link4\n" .
				"            </td>\n" .
				"          </tr>\n" .
				"        </table>\n" .
				"      </div>\n" .
				"      <div id='msg'>$msg</div>\n" .
				"      <div id='content'>\n";

	$header_printed = 1;
}

# Print our html footer
function print_footer()
{
	print	"      </div>\n" .
				"    </div>\n" .
				"  </body>\n" .
				"</html>\n";
}

# Throw an error message and die
function fatal($msg)
{
	global $header_printed;

	if (!$header_printed) print_header();
	print "$msg<br>\n";
	print_footer();
	exit;
}

?>
